/*----------------------------------------------------------------------------*/
/* Includes                                                                   */
/*----------------------------------------------------------------------------*/
#include "DrvI2C.h"
#include "DrvHWI2C.h"
#include "HY2613.h"
#include "seg7.h"

/*--------------------------------------------------------------------------*/
/* Clear LCD RAM Data                                                       */
/*--------------------------------------------------------------------------*/
void ClearLCDframe(void)
{
  int i=0;
  for(i=0;i<11;i++)
  {
    DisplayBuffer[i]=0x00;
  }
  RAM2LCD(DisplayBuffer,11);
}

/*----------------------------------------------------------------------------*/
/* Display HYcon Char                                                         */
/*----------------------------------------------------------------------------*/
void DisplayHYcon(void)
{
  #define offset 2
  DisplayBuffer[offset+0]=0x00;
  DisplayBuffer[offset+1]=Char_H;
  DisplayBuffer[offset+2]=Char_Y;
  DisplayBuffer[offset+3]=Char_c;
  DisplayBuffer[offset+4]=Char_o;
  DisplayBuffer[offset+5]=Char_n;
  RAM2LCD(DisplayBuffer,11);
}

/*--------------------------------------------------------------------*/
/* LCD RAM Data                                                       */
/*--------------------------------------------------------------------*/
void LCD_DATA_DISPLAY(unsigned int LcdBuffer)
{
  int k;
  for(k=7;k>=2;k--)
  {
    DisplayBuffer[k]=seg[LcdBuffer%10];
    LcdBuffer=LcdBuffer/10;
  }
  DisplayBuffer[8]=S_Bat1|S_Bat2|S_Bat3|S_Bat4;
  DisplayBuffer[2]=0x00;
  DisplayBuffer[3]=0x00;
  DisplayBuffer[4]=0x00;
  DisplayBuffer[6]=DisplayBuffer[6]|0x01;
  DisplayBuffer[9]=0x50;
  DisplayBuffer[10]=S18|S19|S20|S21;
  RAM2LCD(DisplayBuffer,11);
} 
