/**********************************************************************
 *HY16F188
 * main.c
 * Created on:2013/12/08
 * Maintenance:2014/10/01
 * --------------------------------------------------------------------
 * Release 1.0.0
 * Program Description:
 * --------------------
 *
 * ---------
 *          |              --------------------
 *    PT2.0 | SDA ---> SDA | LCD Drive HY2613 |
 *    PT2.1 | SCK ---> SCK --------------------
 *     GND  |
 *          |
 * ---------
 **********************************************************************/
/*----------------------------------------------------------------------------*/
/* Includes                                                                   */
/*----------------------------------------------------------------------------*/
#include "HY16F188.h"
#include "System.h"
#include "DrvGPIO.h"
#include "DrvI2C.h"
#include "DrvHWI2C.h"
#include "DrvCLOCK.h"
#include "HY2613.h"
#include "my define.h"

#include "DrvREG32.h"
#include "DrvPMU.h"
#include "DrvCMP.h"
#include "DrvCLOCK.h"
#include "DrvTimer.h"
#include "DrvADC.h"
#include "DrvFlash.h"

/*----------------------------------------------------------------------------*/
/* STRUCTURES                                                                 */
/*----------------------------------------------------------------------------*/
typedef union _MCUSTATUS
{
  char  _byte;
  struct
  {
    unsigned b_ADCdone:1;
    unsigned b_TMAdone:1;
    unsigned b_TMBdone:1;
    unsigned b_TMC0done:1;
    unsigned b_TMC1done:1;
    unsigned b_RTCdone:1;
    unsigned b_UART_TxDone:1;
    unsigned b_UART_RxDone:1;
  };
} MCUSTATUS;

/*----------------------------------------------------------------------------*/
/* DEFINITIONS                                                                */
/*----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
/* Global CONSTANTS                                                           */
/*----------------------------------------------------------------------------*/
MCUSTATUS  MCUSTATUSbits;
extern unsigned char seg[16];
#define  Disable 0
#define  Enable  1
int threh0,threh1,threh2,threh3;						//Utouch ֭
int CL,t,a,b,TCH,cmpresult,tmrbcnt;
signed int sum,ADtemp10,LED,ADCData,c;					//ADC
float gain,temp,tempp,temploop;							//ū׭p
unsigned int unth0,unth1,unth2,unth3,th0,th1,th2,th3;	//touchե
/*----------------------------------------------------------------------------*/
/* Function PROTOTYPES                                                        */
/*----------------------------------------------------------------------------*/
void Delay(unsigned int num);
void ClearLCDframe(void);
void LCD_DATA_DISPLAY(unsigned int LcdBuffer);
void LCD_DATA_DISPLAY1();
void Delay(unsigned int num);
void Ini_Touch(void);
void Initial_Array(void);
void Initial_ALL(void);
void InitalADC(void);
void  ScanKey4(unsigned int TCH);
void AD(void);
void touch_ct(void);
void temp_ct(void);

/*----------------------------------------------------------------------------*/
/* Main Function                                                              */
/*----------------------------------------------------------------------------*/
int main(void)
{
  //unsigned int m;

  DrvCLOCK_EnableHighOSC(E_INTERNAL,50);       // Select HAO 4MHz
  InitalI2C();
  SYS_EnableGIE(7,0x3F);  // Enable GIE(Global Interrupt)

  Ini_Display();
  ClearLCDframe();
  Delay(10000);
  //DisplayHYcon();
  LCD_DATA_DISPLAY(123456);

  Delay(50000);
  MCUSTATUSbits._byte = 0;

  Ini_Touch();
  InitalADC();
  Initial_ALL();

  a=ReadWord(0x8000);					//P_ū׬O_QեLApGQեLFlash
  if(a==0x1110)
  {
  	  temp=ReadWord(0x8004);
  	  tempp=ReadWord(0x8008);
  }
  else									//pGP_SեLA]w
  {
	  temp=6047;
	  tempp=25;
  }

  a=ReadWord(0x800c);					//P_touchO_QեLApGQեLFlash
  if(b==0x5566)
  {

	  threh0=ReadWord(0x8010);
	  threh1=ReadWord(0x8014);
	  threh2=ReadWord(0x8018);
	  threh3=ReadWord(0x801c);
  }
  else									//pGP_SեLA]w
  {
	  touch_ct();
	  //threh0=300;//CL0
	  //threh1=220;//CL1
	  //threh2=155;//CL2
	  //threh3=150;//CL3
  }

  while(1)
  {

  pmu_00=0xff00ff00;			//N\(ٹq)
  cmp_00=0xff00;
  cmp_04=0xff00ff00;
  asm("NOP");
  clk_08=0xff00ff0d;			//t_AϥΧCt(ٹq)
  Delay(0x100);
  clk_00=0xff00ff00;
  sys_04=0xff10;
  //asm("standby 0");
  asm("NOP");
  DrvADC_Disable();				//ADC\(ٹq)



	  if(t==1)					//(t=1NTMAwiJ_)
	  {
		  t=0;					//CPU
		  pmu_00=0x03031b1b;	//}Ҥ\(}touch\)
		  cmp_00=0x13c3c;
		  cmp_04=0x101d3d3;

		  clk_00=0xff01;		//}Ұt
		  clk_08=0xff4c;
		  TCH=0;ScanKey4(TCH);	//ytouch1O_QUAtouch1QULED+1
		  if(LED==1)
		  {
			  while(1)
			  {
				  DrvADC_Enable();				//}ADC\
				  AD();							//ADCƵ{
				  gain=(296+tempp)/temp;		//ū״
				  temploop=gain*sum-296;
				  temploop*=10;
				  LCD_DATA_DISPLAY(temploop);	//ܲ{bū

				  if(LED==15)					//tocuh1ɶƫLED[15ɡA}ūܡAAiJٹqA
				  {
					  LED=0;
					  ClearLCDframe();
					  Delay(0xFF00);
					  goto bb;
				  }
				  TCH=3;ScanKey4(TCH);			//ūܤUApGtouch4UAiJtouchեҦ(touch4U LED=10000)
				  if(c==-15)
				  {
					  touch_ct();				//Istouchեt{
				  }
				  TCH=2;ScanKey4(TCH);			//touch2UɡALED|1ALED-15ɡAiJū׮ե
				  if(c==15)
				  {
					  temp_ct();				//Isū׮եƵ{
				  }
				  Delay(0x2000);
				  TCH=0;ScanKey4(TCH);
			  }
		  }
	  }
	  t=0;
bb:	  ClearLCDframe();							//MLCD
  }















  return 0;
}

/*---------------------------------------------------------------------------*/
/* Hardware Communication Interrupt                                          */
/* UART/SPI/I2C Interrupt Service Routines                                   */
/*---------------------------------------------------------------------------*/
void HW0_ISR(void)
{
  unsigned char I2C_Status;

  if(DrvI2C_ReadIntFlag()==E_DRVI2C_INT)  // Get I2C Interrupt Flag
  {
    I2C_Status=DrvI2C_GetStatusFlag();  // Get I2C Status Flag
    switch(I2C_Status)
    {
      case 0x90: //MACTFlag+RWFlag
          { /* START has been transmitted */
            DrvI2C_WriteData(I2C_TARGET);  //Send Slave Address & R/W Bit
            DrvI2C_Ctrl(0,0,0,0);  // Clear all I2C flag
            break;
          };
      case 0x84: //MACTFlag+ACKFlag
          { /* Slave A + W has been transmitted. ACK has been received. */
            DrvI2C_WriteData(Sendbuf[DataTxIndex++]);  //Send Data to Slave
            DrvI2C_Ctrl(0,0,0,0);  // Clear all I2C flag
            break;
          };
      case 0x80: //MACTFlag
          { /* Slave A + W has been transmitted. ACK has been received. */
            DrvI2C_WriteData(Sendbuf[DataTxIndex++]);  //Send Data to Slave
            DrvI2C_Ctrl(0,0,0,0);  // Clear all I2C flag
            break;
          };
      case 0x30:
          {
            DrvI2C_Ctrl(0,0,0,0);  // Clear all I2C flag
            EndFlag=1;
            break;
          };
      case 0x8C: // MACTFlag+DFFlag+ACKFlag
          { /* DATA has been transmitted and ACK has been received */
            if(DataTxIndex<DataTxLen)
            {
              DrvI2C_WriteData(Sendbuf[DataTxIndex++]);  //Send Data to Slave
              DrvI2C_Ctrl(0,0,0,0);  // Clear all I2C flag
            }
            else
            {
              if(I2C_RW == WRITE)
              {
                DrvI2C_Ctrl(0,1,0,0);  // I2C as master sends STOP signal
                EndFlag=1;
              }
              else if(I2C_RW == READ)
                DrvI2C_Ctrl(1,0,0,0);  // I2C as master sends START signal
              DataTxIndex=0;
            }
            break;
          };
      case 0x88: //MACTFlag+DFFlag
          { /* DATA has been transmitted and NACK has been received */
            DrvI2C_Ctrl(0,1,0,0);  // I2C as master sends STOP signal
            DataTxIndex=0;
            EndFlag=1;
            break;
          };
      case 0xB0:
          { /* A repeated START has been transmitted. */
            DrvI2C_WriteData(I2C_TARGET | READ);  //Send Slave Address & R/W Bit
            DrvI2C_Ctrl(0,0,0,0);  // Clear all I2C flag
            break;
          }
      case 0x94: //MACTFlag+RWFlag
          { /* Slave A + R has been transmitted. ACK has been received. */
            DrvI2C_Ctrl(0,0,0,1);  // Set ACK bit
            break;
          };
      case 0x9C: //MACTFlag+RWFlag+DFFlag+ACKFlag
          { /* Data byte has been received. ACK has been transmitted. */
            if(DataRxLen>DataRxIndex)
            {
              Recbuf[DataRxIndex++]=DrvI2C_ReadData();
              DrvI2C_Ctrl(0,0,0,0);  // Clear all I2C flag
            }
            else
            {
              Recbuf[DataRxIndex++]=DrvI2C_ReadData();
              DrvI2C_Ctrl(0,1,0,0);  // I2C as master sends STOP signal
              EndFlag=1;
            }
            break;
          };
      case 0x98: //MACTFlag+RWFlag+DFFlag
          { /* Data byte has been received. NACK has been transmitted. */
            DrvI2C_Ctrl(0,1,0,0);  // I2C as master sends STOP signal
            EndFlag=1;
            break;
          };
      default:
          {
            DrvI2C_Ctrl(0,0,0,0);  // Clear all I2C flag
            EndFlag=1;
            break;
          };
    }
    DrvI2C_ClearEIRQ();
    DrvI2C_ClearIntFlag(2); // Clear I2C Interrupt Flag(I2CIF)
    SYS_EnableGIE(7,0x3F);       // Enable GIE(Global Interrupt)
  }
  if(DrvI2C_ReadIntFlag()==E_DRVI2C_ERROR_INT)  //Get I2C Error Interrupt Flag
  {
    EndFlag=1;
    DrvI2C_ClearIRQ();
    DrvI2C_ClearIntFlag(2); // Clear I2C Interrupt Flag(I2CEIF)
    DrvI2C_Ctrl(0,1,0,0);   // I2C as master sends STOP signal
    SYS_EnableGIE(7,0x3F);       // Enable GIE(Global Interrupt)
  }
}




/*---------------------------------------------------------------------------*/
/* Software Delay Subroutines                                                */
/*---------------------------------------------------------------------------*/
void Delay(unsigned int num)
{
  for(;num>0;num--)
    asm("NOP");
}

/*----------------------------------------------------------------------------*/
void ScanKey4(unsigned int TCH)						//touch keyƵ{
{
  CL=TCH;pio_00=0x0100;
  DrvTMB_ClearTMB();
  DrvCMP_EnableNonOverlap(CL);
  cmpresult=DrvCMP_ReadData();
  while(cmpresult==1){cmpresult=DrvCMP_ReadData();}
  tmrbcnt=DrvTMB_CounterRead();//TMB				//P_RqɶO_C֭
  switch(CL)
  {
    case 0 : if(tmrbcnt<=threh0){LED++;}break;
    case 1 : if(tmrbcnt<=threh1){LED--;}break;
    case 2 : if(tmrbcnt<=threh2){c++;}break;
    case 3 : if(tmrbcnt<=threh3){c--;}break;
    default: LED=0;
  }
  pio_00=0x0101;
  pio_04=0x0100;

}

/*---------------------------------------------------------------------------*/
/* End Of File                                                               */
/*---------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
void HW1_ISR(void)									//TMA_Ƶ{
{
  DrvTIMER_ClearIntFlag(E_TMA);	        //Clear TMA interrupt flag
  t=1;
  asm volatile("sethi $r0, 0xc0000");				//w_iw
  asm volatile("ori  $r0, $r0, 0x003f");
  asm volatile("mtsr $r0, $INT_MASK");
  asm volatile("movi $r0, 0x70009");
  asm volatile("mtsr $r0, $PSW");
}
/*----------------------------------------------------------------------------*/
void HW2_ISR(void)									//AD_Ƶ{
{
  DrvADC_ClearIntFlag();				//MAD_X
  ADCData=adc_08;
  asm volatile("sethi $r0, 0xc0000");				//w_iw
  asm volatile("ori  $r0, $r0, 0x003f");
  asm volatile("mtsr $r0, $INT_MASK");
  asm volatile("movi $r0, 0x70009");
  asm volatile("mtsr $r0, $PSW");
}
/*----------------------------------------------------------------------------*/
void temp_ct(void)								//ū׮եƵ{
{
	int a,d;
	d=0;
	c=0;
	for(a=0;a<8;a++)							//NTPSҴoƭȨ8ᥭ
	{
		AD();
		d+=sum;
		LCD_DATA_DISPLAY(sum);
		Delay(0xff00);
	}
	d=d>>3;
	temp=d;										//NADȩJ ū׭pμȦs
	LED=tempp;									//]w{bū
	while(1)
	{
		LCD_DATA_DISPLAY(LED);
		Delay(0xf000);
		TCH=0;ScanKey4(TCH);					//touch1=ūפWɤ@
		TCH=1;ScanKey4(TCH);					//touch2=ūפU@
		TCH=2;ScanKey4(TCH);					//touch3Tw
		if(c==3)
		{
			ClearLCDframe();					//MLCD
			c=0;
			tempp=LED;							//N]wȩJū׹BȦs
			DrvADC_DisableInt();				//ADC_
			DrvTIMER_DisableInt(E_TMA);			//TMA_
			DrvFlash_Burn_Word(0x8000,0x600,0x1110);	//NP_O_եLμƭȿNJFlash
			DrvFlash_Burn_Word(0x8008,0x600,tempp);	//NեȿNJFlash
			DrvFlash_Burn_Word(0x8004,0x600,temp);
			Delay(0xff00);
			DrvTIMER_EnableInt(E_TMA);			//}TMA_
			DrvADC_EnableInt();					//}_ADC_
			LED=0;
			break;
		}
	}
}
/*----------------------------------------------------------------------------*/
void touch_ct(void)								//touch keyեƵ{
{
	int z,y;

		 LCD_DATA_DISPLAY(888888);
		 unth0=0;								//touch1 untouch(8)
		 for(z=0;z<8;z++)
		 {
			 TCH=0;ScanKey4(TCH);
			 unth0+=tmrbcnt;
			 Delay(0xFFF);
		 }
		 unth0=unth0>>3;
		 LCD_DATA_DISPLAY(777777);
		 unth1=0;								//touch2 untouch(8)
		 for(z=0;z<8;z++)
		 {
			 TCH=1;ScanKey4(TCH);
			 unth1+=tmrbcnt;
			 Delay(0xFFF);
		 }
		 unth1=unth1>>3;
		 LCD_DATA_DISPLAY(666666);
		 unth2=0;								//touch3 untouch(8)
		 for(z=0;z<8;z++)
		 {
			 TCH=2;ScanKey4(TCH);
			 unth2+=tmrbcnt;
			 Delay(0xFFF);
		 }
		 unth2=unth2>>3;
		 LCD_DATA_DISPLAY(555555);
		 unth3=0;								//touch4 untouch(8)
		 for(z=0;z<8;z++)
		 {
			 TCH=3;ScanKey4(TCH);
			 unth3+=tmrbcnt;
			 Delay(0xfff);
		 }
		 unth3=unth3>>3;
		 LCD_DATA_DISPLAY(994444);
		 th0=0;									//touch1 touch(8)
		 y=8;
		 while(y)
		 {
			 TCH=0;ScanKey4(TCH);
			 if(tmrbcnt<435)
			{
				 y--;
				 th0+=tmrbcnt;
			}
		 }
		 th0=th0>>3;
		 LCD_DATA_DISPLAY(993333);
		 th1=0;									//touch2 touch(8)
		 y=8;
		 while(y)
		 {
			 TCH=1;ScanKey4(TCH);
			 if(tmrbcnt<220)
			 {
			 	y--;
			 	th1+=tmrbcnt;
			 }
		 }
		 th1=th1>>3;
		 LCD_DATA_DISPLAY(992222);
		 th2=0;									//touch3 touch(8)
		 y=8;
		 while(y)
		 {
			 TCH=2;ScanKey4(TCH);
			 if(tmrbcnt<180)
			 {
				 y--;
				 th2+=tmrbcnt;
			 }
		 }
		 th2=th2>>3;
		 LCD_DATA_DISPLAY(991111);
		 th3=0;									//touch4 touch(8)
		 y=8;
		 while(y)
		 {
			 TCH=3;ScanKey4(TCH);
			 if(tmrbcnt<180)
			 {
				 y--;
				 th3+=tmrbcnt;
			 }
		 }
		 th3=th3>>3;
		 threh0=unth0-(((unth0-th0)*3)/4);		//pե
		 threh1=unth1-(((unth1-th1)*3)/4);
		 threh2=unth2-(((unth2-th2)*3)/4);
		 threh3=unth3-(((unth3-th3)*3)/4);
		 LED=0;
		 c=0;
		 DrvADC_DisableInt();					//ADC_
		 DrvTIMER_DisableInt(E_TMA);			//TMA_
		 DrvFlash_Burn_Word(0x800c,0x600,0x5566);		//NP_O_եLέȡAsJFlach
		 DrvFlash_Burn_Word(0x8010,0x600,threh0);		//NեȦsJFlash
		 DrvFlash_Burn_Word(0x8014,0x600,threh1);
		 DrvFlash_Burn_Word(0x8018,0x600,threh2);
		 DrvFlash_Burn_Word(0x801c,0x600,threh3);
		 Delay(0x8000);
		 DrvTIMER_EnableInt(E_TMA);				//}TMA_
		 DrvADC_EnableInt();					//}ADC_
}
/*----------------------------------------------------------------------------*/
void AD(void)									//ADCƵ{
{
	int h;
	sum=0;
	for(h=0;h<8;h++)							//8
	{
		ADtemp10=(ADCData>>14);
		sum=sum+ADtemp10;
	}
	sum=sum>>3;
}












void InitalADC(void)
{
  //Set ADC input pin
  //DrvADC_SetADCInputChannel(ADC_Input_AIO3,ADC_Input_AIO2);//ADC Input
	//DrvADC_SetADCInputChannel(ADC_Input_TPSP0);//ADC Input
  //DrvADC_PInputChannel(TPS1);
  //DrvADC_NInputChannel(TPS0);
  adc_04=0x7676;
  DrvADC_InputSwitch(OPEN);
  DrvADC_RefInputShort(OPEN);
  DrvADC_Gain(0,0);          //Set the ADC Gain
  DrvADC_DCoffset(0);        //DC offset input voltage selection
  DrvADC_RefVoltage(VDDA,0); //Set the ADC reference voltage.
  DrvADC_FullRefRange(1);    //Set the ADC reference range select.
                             //0:Full reference range input
                             //1:1/2 reference range input
  DrvADC_OSR(0);             //0:OSR=32768
  DrvADC_CombFilter(Enable);
  DrvADC_ClkEnable(0,1);     //Setting ADC CLOCK ADCK=HS_CK/6
  //Set VDDA voltage
  DrvPMU_VDDA_Voltage(E_VDDA2_4);
  DrvPMU_VDDA_LDO_Ctrl(E_LDO);
  DrvPMU_BandgapEnable();
  DrvPMU_REFO_Enable();
  DrvPMU_AnalogGround(Enable);//ADC analog ground source selection.
                              //1:Enable buffer and use internal source
  DrvPMU_LDO_LowPower(0);     //VDD LDO with low power control.
                              //0 : Normal;1 : Low power
  Delay(0x1000);
  //Set ADC interrupt
  DrvADC_EnableInt();
  DrvADC_ClearIntFlag();
  DrvADC_Disable();
}
void Initial_ALL(void)
{
	  pio_00=0xff00ff00;				  //TOSΪ}
	  pio_04=0xff00ff00;
	  pio_08=0x00;
	  pio_10=0xff00ff03;
	  pio_14=0xff00ff03;

	  LED=0;
	  t=0;
	  TCH=0;
	  c=0;

	  DrvTMA_Open(9,1);                   //TimerA Overflow
	                                      //9:taclk/1024/32;TMRDV=32
	                                      //00:HS_CK
	  DrvTIMER_ClearIntFlag(E_TMA);       //Clear Timer A interrupt flag
	  DrvTIMER_EnableInt(E_TMA);          //Timer A interrupt enable

	  SYS_EnableGIE(7,0X3F);	                  //Enable GIE
}
void Ini_Touch(void)
{
  DrvCMP_Enable();                                //CMP enable
  DrvCMP_Open(1,1,1);                             //CMP open
  DrvCMP_PInput(0);                               //Comparator positive input  CH1
  DrvCMP_NInput(3);                               //Comparator negative input  RLO
  DrvCMP_RLO_refV(2,1);
  DrvCMP_DisableNonOverlap();
  DrvCMP_RLO_Ctrl(0,1);
  DrvCMP_InputSwitch(1);
  DrvCMP_InputSwitch(0);
  DrvCMP_RLO_Ctrl(1,0);
  DrvTMB_ClearTMB();
  DrvCLOCK_SelectIHOSC(0x00);
  DrvCLOCK_SelectMCUClock(0,0);                   //select MCU clock as LS_CK,div1
  DrvTMBC_Clk_Source(1,0);//(1,0)                 //TimerB Clock enable pre_scale 1
  DrvTMB_Open(E_TMB_MODE0,E_TMB_CMP_HIGH,0xffff); //TimerB overflow 0xffff->PWM period 0xffff
  DrvTMB_ClearTMB();
  //Set VDDA voltage
  DrvPMU_VDDA_Voltage(E_VDDA2_4);
  DrvPMU_VDDA_LDO_Ctrl(E_LDO);
  DrvPMU_BandgapEnable();
  DrvPMU_REFO_Enable();
  DrvPMU_AnalogGround(Enable);                    //ADC analog ground source selection.
                                                  //1 : Enable buffer and use internal source(need to work with ADC)
  DrvPMU_LDO_LowPower(Enable);                    //VDD LDO with low power control.//0 : Normal;1 : Low power
  Delay(0x1000);
}











